#include <iostream>
#include <assert.h>
#include <cilk/cilk.h>
#include <cilk/cilk_api.h>
#include <cilktools/cilkview.h>
using namespace std;

#define BASE 25

long fib_serial(long n)
{
    if (n < 2) return n;
        return fib_serial(n-1)+fib_serial(n-2);
}

long fib_parallel(long n)
{
    long x, y;
    if (n < 2) 
	return n;
    else if (n < BASE)
		{return fib_serial(n);}
		else
			{
				x = cilk_spawn fib_parallel(n-1);
    				y = fib_parallel(n-2);
    				cilk_sync;
    				return (x+y);
			}
}
long
fib[]={0,1,1,2,3,5,8,13,21,34,55, 89, 144, 233, 377, 610, 987, 1597, 2584, 4181, 6765, 10946, 17711, 28657, 46368, 75025, 121393, 196418, 317811, 514229, 832040, 1346269, 2178309, 3524578, 5702887, 9227465, 14930352, 24157817, 39088169, 63245986, 102334155, 165580141, 267914296, 433494437, 701408733, 1134903170, 1836311903, 2971215073, 4807526976, 7778742049, 12586269025, 20365011074, 32951280099, 53316291173, 86267571272, 139583862445, 225851433717, 365435296162, 591286729879, 956722026041, 1548008755920};


long fib_parallel_check(long n)
{
    long x, y;
    if (n < 2) 
	return n;
    else if (n < BASE)
		{return fib_serial(n);}
		else
			{
				x = cilk_spawn fib_parallel_check(n-1);
    				y = fib_parallel_check(n-2);
    				cilk_sync;
				long re = x+y;
				assert(re == fib[n]); 
    				return re;
			}
}

int main(int argc, char * argv[]) 
{
        //unsigned long long start,end,run_time,run_time1;
        double start,end,run_time,run_time1;
        long n,s;

	if (argc == 1)
	{
		cout<<"Usage: ./fibo workers order [check]"<<endl;
        	exit(0);
	}
	else if ( argc > 2 )
        {
                __cilkrts_set_param("nworkers", argv[1]);
        	n = atoi(argv[2]);
	}

        cout<<"Using "<<__cilkrts_get_nworkers()<<" workers"<<endl;
	cout<<"fibonacci order "<<argv[2]<<endl;
        start = __cilkview_getticks();
	if(argc == 4)
 	{
	    	        fib_parallel_check(n);
	}
	else
	{
		fib_parallel(n);        
        }
	end = __cilkview_getticks();

        run_time = (end - start) / 1.f;

        cout<< " cilk parallel fibonacci = " << run_time << " mseconds" <<endl;

        fflush(stdout);

        start = __cilkview_getticks();

        fib_serial(n);
//cout<<fib_serial(n); 

        end = __cilkview_getticks();

        run_time1 = (end - start) / 1.f;

        cout<< "cilk serial fibonacci = " << run_time1 << " mseconds" <<endl;
        cout<<"cilk speedup = " << run_time1/run_time<< " times" <<endl;

}
